/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_13 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_14 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_15 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_16 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_19 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_20 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern0 (x3, SImode); /* [-1, 0] */

    case DImode:
      if (pattern0 (x3, DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      return pattern0 (x3, SFmode); /* [-1, 0] */

    case DFmode:
      if (pattern0 (x3, DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern3 (x3, SImode); /* [-1, 0] */

    case DImode:
      if (pattern3 (x3, DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern5 (x3, SImode); /* [-1, 1] */

    case DImode:
      res = pattern5 (x3, DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!register_operand (operands[0], SFmode)
          || GET_MODE (x3) != SFmode)
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[0], DFmode)
          || GET_MODE (x3) != DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x1) != SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case SImode:
          if (!register_operand (operands[1], SImode))
            return -1;
          return 0;

        case DImode:
          if (!register_operand (operands[1], DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case DImode:
      if (!register_operand (operands[0], DImode)
          || GET_MODE (x1) != DImode
          || !register_operand (operands[1], DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern8 (x2); /* [-1, 2] */
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case SFmode:
      if (!register_operand (operands[0], SFmode)
          || GET_MODE (x1) != SFmode
          || !register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[0], DFmode)
          || GET_MODE (x1) != DFmode
          || !register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode
      || !register_operand (operands[0], DImode)
      || GET_MODE (x1) != DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], SImode))
    return -1;
  return 0;
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode
      || !register_operand (operands[0], DImode)
      || GET_MODE (x1) != DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], SImode))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!register_operand (operands[1], SFmode)
          || !register_operand (operands[2], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[1], DFmode)
          || !register_operand (operands[2], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern13 (x3, SImode); /* [-1, 1] */

    case DImode:
      res = pattern13 (x3, DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x1) != SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case SImode:
          if (!register_operand (operands[1], SImode)
              || !reg_or_0_operand (operands[2], SImode))
            return -1;
          return 0;

        case DImode:
          if (!register_operand (operands[1], DImode)
              || !reg_or_0_operand (operands[2], DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case DImode:
      if (!register_operand (operands[0], DImode)
          || GET_MODE (x1) != DImode
          || !register_operand (operands[1], DImode)
          || !reg_or_0_operand (operands[2], DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x1) != SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case SImode:
          if (!register_operand (operands[1], SImode)
              || !arith_operand (operands[2], SImode))
            return -1;
          return 0;

        case DImode:
          if (!register_operand (operands[1], DImode)
              || !arith_operand (operands[2], DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case DImode:
      if (pattern3 (x1, DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x1) != SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case SImode:
          if (!register_operand (operands[1], SImode)
              || !sle_operand (operands[2], SImode))
            return -1;
          return 0;

        case DImode:
          if (!register_operand (operands[1], DImode)
              || !sle_operand (operands[2], DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case DImode:
      if (!register_operand (operands[0], DImode)
          || GET_MODE (x1) != DImode
          || !register_operand (operands[1], DImode)
          || !sle_operand (operands[2], DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!equality_operator (x3, VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x2, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x1, 0);
  if (GET_CODE (x9) != PC)
    return -1;
  return 0;
}

static int
pattern19 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != SImode)
    return -1;
  return 0;
}

static int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case QImode:
      if (!nonimmediate_operand (operands[1], QImode))
        return -1;
      return 0;

    case HImode:
      if (!nonimmediate_operand (operands[1], HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], HImode)
      || GET_MODE (x1) != HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case HImode:
      if (!register_operand (operands[1], HImode)
          || !arith_operand (operands[2], HImode))
        return -1;
      return 0;

    case SImode:
      if (!register_operand (operands[1], SImode)
          || !arith_operand (operands[2], SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x1) != SImode
          || !symbolic_operand (operands[1], SImode))
        return -1;
      return 0;

    case DImode:
      if (!register_operand (operands[0], DImode)
          || GET_MODE (x1) != DImode
          || !symbolic_operand (operands[1], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!register_operand (operands[1], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[1], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern26 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !fp_native_comparison (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case SFmode:
      if (!register_operand (operands[2], SFmode)
          || !register_operand (operands[3], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[2], DFmode)
          || !register_operand (operands[3], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern28 (x1, SImode); /* [-1, 0] */

    case DImode:
      if (pattern28 (x1, DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern30 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (XWINT (x6, 0))
    {
    case 64LL:
      return pattern30 (x1, DImode, TImode); /* [-1, 0] */

    case 32LL:
      if (pattern30 (x1, SImode, DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern36 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !symbolic_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !symbolic_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern42 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case DImode:
      if (!scratch_operand (operands[2], DImode))
        return -1;
      return 0;

    case SImode:
      if (!scratch_operand (operands[2], SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern43 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case DImode:
      if (!scratch_operand (operands[2], DImode))
        return -1;
      return 0;

    case SImode:
      if (!scratch_operand (operands[2], SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case DImode:
      if (!scratch_operand (operands[2], DImode))
        return -1;
      return 0;

    case SImode:
      if (!scratch_operand (operands[2], SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case SFmode:
      if (!register_operand (operands[1], SFmode)
          || !register_operand (operands[2], SFmode))
        return -1;
      return 0;

    case DFmode:
      if (!register_operand (operands[1], DFmode)
          || !register_operand (operands[2], DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      return pattern47 (x1, SImode); /* [-1, 0] */

    case DImode:
      if (pattern47 (x1, DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case SImode:
      if (!register_operand (operands[2], SImode)
          || !scratch_operand (operands[4], SImode))
        return -1;
      return 0;

    case DImode:
      if (!register_operand (operands[2], DImode)
          || !scratch_operand (operands[4], DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  if (!branch_on_bit_operand (operands[3], VOIDmode))
    return -1;
  return pattern49 (x1); /* [-1, 1] */
}

static int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  if (!branch_on_bit_operand (operands[3], VOIDmode))
    return -1;
  return pattern49 (x1); /* [-1, 1] */
}

static int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[6], i1))
    return -1;
  return 0;
}

static int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case DImode:
      if (nonimmediate_operand (operands[0], DImode)
          && move_operand (operands[1], DImode))
        {
          if (
#line 1234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
            return 130; /* *movdi_32bit */
          if (
#line 1244 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
            return 131; /* *movdi_64bit */
        }
      break;

    case SImode:
      if (nonimmediate_operand (operands[0], SImode)
          && move_operand (operands[1], SImode)
          && 
#line 1265 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))))
        return 132; /* *movsi_internal */
      break;

    case HImode:
      if (nonimmediate_operand (operands[0], HImode)
          && move_operand (operands[1], HImode)
          && 
#line 1290 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))))
        return 133; /* *movhi_internal */
      break;

    case QImode:
      if (nonimmediate_operand (operands[0], QImode)
          && move_operand (operands[1], QImode)
          && 
#line 1331 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))))
        return 138; /* *movqi_internal */
      break;

    case SFmode:
      if (nonimmediate_operand (operands[0], SFmode)
          && move_operand (operands[1], SFmode))
        {
          if (
#line 1351 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
            return 139; /* *movsf_hardfloat */
          if (
#line 1361 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
            return 140; /* *movsf_softfloat */
        }
      break;

    case DFmode:
      if (nonimmediate_operand (operands[0], DFmode)
          && move_operand (operands[1], DFmode))
        {
          if (
#line 1384 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 141; /* *movdf_hardfloat_rv32 */
          if (
#line 1394 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 142; /* *movdf_hardfloat_rv64 */
          if (
#line 1404 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 143; /* *movdf_softfloat */
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x2) != MEM)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!absolute_symbolic_operand (operands[0], VOIDmode))
    return -1;
  operands[1] = x3;
  switch (GET_MODE (x2))
    {
    case QImode:
      if (!reg_or_0_operand (operands[1], QImode))
        return -1;
      if (
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
        {
          *pnum_clobbers = 1;
          return 268; /* *local_pic_storediqi */
        }
      if (!
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
        return -1;
      *pnum_clobbers = 1;
      return 272; /* *local_pic_storesiqi */

    case HImode:
      if (!reg_or_0_operand (operands[1], HImode))
        return -1;
      if (
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
        {
          *pnum_clobbers = 1;
          return 269; /* *local_pic_storedihi */
        }
      if (!
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
        return -1;
      *pnum_clobbers = 1;
      return 273; /* *local_pic_storesihi */

    case SImode:
      if (!reg_or_0_operand (operands[1], SImode))
        return -1;
      if (
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
        {
          *pnum_clobbers = 1;
          return 270; /* *local_pic_storedisi */
        }
      if (!
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
        return -1;
      *pnum_clobbers = 1;
      return 274; /* *local_pic_storesisi */

    case DImode:
      if (!reg_or_0_operand (operands[1], DImode))
        return -1;
      if ((
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 266 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 271; /* *local_pic_storedidi */
        }
      if (!(
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 266 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 275; /* *local_pic_storesidi */

    case SFmode:
      if (!register_operand (operands[1], SFmode))
        return -1;
      if ((
#line 75 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
        {
          *pnum_clobbers = 1;
          return 276; /* *local_pic_storedisf */
        }
      if (!(
#line 83 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
        return -1;
      *pnum_clobbers = 1;
      return 278; /* *local_pic_storesisf */

    case DFmode:
      if (!register_operand (operands[1], DFmode))
        return -1;
      if ((
#line 75 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
        {
          *pnum_clobbers = 1;
          return 277; /* *local_pic_storedidf */
        }
      if (!(
#line 83 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      *pnum_clobbers = 1;
      return 279; /* *local_pic_storesidf */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 0);
  operands[0] = x9;
  switch (GET_MODE (operands[2]))
    {
    case SImode:
      if (!register_operand (operands[2], SImode)
          || !register_operand (operands[3], SImode)
          || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
        return -1;
      return 155; /* *branch_ordersi */

    case DImode:
      if (!register_operand (operands[2], DImode)
          || !register_operand (operands[3], DImode)
          || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 156; /* *branch_orderdi */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[0] = x9;
  switch (GET_MODE (operands[2]))
    {
    case SImode:
      if (!register_operand (operands[2], SImode)
          || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
        return -1;
      return 157; /* *branch_zerosi */

    case DImode:
      if (!register_operand (operands[2], DImode)
          || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 158; /* *branch_zerodi */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      switch (pattern26 (SImode))
        {
        case 0:
          if (!(
#line 1659 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && ((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))))
            return -1;
          return 163; /* *cstoresfsi4 */

        case 1:
          if (!(
#line 1659 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && ((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))))
            return -1;
          return 165; /* *cstoredfsi4 */

        default:
          return -1;
        }

    case DImode:
      switch (pattern26 (DImode))
        {
        case 0:
          if (!(
#line 1659 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && ((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))))
            return -1;
          return 164; /* *cstoresfdi4 */

        case 1:
          if (!(
#line 1659 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && ((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))))
            return -1;
          return 166; /* *cstoredfdi4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      switch (XINT (x2, 1))
        {
        case 11:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case SFmode:
              if (pattern27 (x2, SFmode) != 0
                  || !
#line 876 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 59; /* copysignsf3 */

            case DFmode:
              if (pattern27 (x2, DFmode) != 0
                  || !(
#line 876 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 60; /* copysigndf3 */

            default:
              return -1;
            }

        case 9:
          switch (pattern14 (x1, pnum_clobbers))
            {
            case 0:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 167; /* flt_quietsfsi4 */

            case 1:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 171; /* flt_quietdfsi4 */

            case 2:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 169; /* flt_quietsfdi4 */

            case 3:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 173; /* flt_quietdfdi4 */

            default:
              return -1;
            }

        case 10:
          switch (pattern14 (x1, pnum_clobbers))
            {
            case 0:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 168; /* fle_quietsfsi4 */

            case 1:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 172; /* fle_quietdfsi4 */

            case 2:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 170; /* fle_quietsfdi4 */

            case 3:
              if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                return -1;
              *pnum_clobbers = 1;
              return 174; /* fle_quietdfdi4 */

            default:
              return -1;
            }

        case 14:
          if (GET_MODE (x2) != BLKmode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != BLKmode)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != SCRATCH)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (!register_operand (operands[0], SImode)
                  || !register_operand (operands[1], SImode)
                  || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
                return -1;
              return 226; /* stack_tiesi */

            case DImode:
              if (!register_operand (operands[0], DImode)
                  || !register_operand (operands[1], DImode)
                  || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 227; /* stack_tiedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 12:
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              switch (pattern25 (x2, SImode))
                {
                case 0:
                  if (!
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 110; /* lrintsfsi2 */

                case 1:
                  if (!(
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 114; /* lrintdfsi2 */

                default:
                  return -1;
                }

            case DImode:
              switch (pattern25 (x2, DImode))
                {
                case 0:
                  if (!(
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))))
                    return -1;
                  return 112; /* lrintsfdi2 */

                case 1:
                  if (!(
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))))
                    return -1;
                  return 116; /* lrintdfdi2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 13:
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              switch (pattern25 (x2, SImode))
                {
                case 0:
                  if (!
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 111; /* lroundsfsi2 */

                case 1:
                  if (!(
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 115; /* lrounddfsi2 */

                default:
                  return -1;
                }

            case DImode:
              switch (pattern25 (x2, DImode))
                {
                case 0:
                  if (!(
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))))
                    return -1;
                  return 113; /* lroundsfdi2 */

                case 1:
                  if (!(
#line 1117 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))))
                    return -1;
                  return 117; /* lrounddfdi2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          switch (pattern23 (x2))
            {
            case 0:
              if (!
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
                return -1;
              return 118; /* got_loadsi */

            case 1:
              if (!
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
                return -1;
              return 119; /* got_loaddi */

            default:
              return -1;
            }

        case 7:
          switch (pattern23 (x2))
            {
            case 0:
              if (!
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
                return -1;
              return 122; /* got_load_tls_gdsi */

            case 1:
              if (!
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
                return -1;
              return 123; /* got_load_tls_gddi */

            default:
              return -1;
            }

        case 6:
          switch (pattern23 (x2))
            {
            case 0:
              if (!
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
                return -1;
              return 124; /* got_load_tls_iesi */

            case 1:
              if (!
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
                return -1;
              return 125; /* got_load_tls_iedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (XINT (x2, 1))
        {
        case 5:
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (pattern36 (x2, SImode) != 0
                  || !
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
                return -1;
              return 120; /* tls_add_tp_lesi */

            case DImode:
              if (pattern36 (x2, DImode) != 0
                  || !
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
                return -1;
              return 121; /* tls_add_tp_ledi */

            default:
              return -1;
            }

        case 8:
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (pattern37 (x2, SImode) != 0
                  || !
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
                return -1;
              return 126; /* auipcsi */

            case DImode:
              if (pattern37 (x2, DImode) != 0
                  || !
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
                return -1;
              return 127; /* auipcdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern11 (x3) != 0
          || !
#line 432 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 5; /* *addsi3_extended */

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x4) == SUBREG
          && XINT (x4, 1) == 0
          && GET_MODE (x4) == SImode
          && register_operand (operands[0], DImode)
          && GET_MODE (x3) == DImode)
        {
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) == DImode)
            {
              switch (GET_CODE (x5))
                {
                case PLUS:
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (register_operand (operands[1], DImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (arith_operand (operands[2], DImode)
                          && 
#line 443 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                        return 6; /* *addsi3_extended2 */
                    }
                  break;

                case MINUS:
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (reg_or_0_operand (operands[1], DImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (register_operand (operands[2], DImode)
                          && 
#line 499 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                        return 12; /* *subsi3_extended2 */
                    }
                  break;

                case MULT:
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (register_operand (operands[1], DImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (register_operand (operands[2], DImode)
                          && 
#line 555 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && TARGET_64BIT))
                        return 18; /* *mulsi3_extended2 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case DImode:
          if (!register_operand (operands[0], DImode)
              || GET_MODE (x3) != DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case SImode:
              if (!nonimmediate_operand (operands[1], SImode)
                  || !
#line 1039 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 86; /* extendsidi2 */

            case QImode:
              if (!nonimmediate_operand (operands[1], QImode)
                  || !
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 89; /* extendqidi2 */

            case HImode:
              if (!nonimmediate_operand (operands[1], HImode)
                  || !
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 92; /* extendhidi2 */

            default:
              return -1;
            }

        case HImode:
          switch (pattern20 (x3, HImode))
            {
            case 0:
              return 87; /* extendqihi2 */

            case 1:
              return 90; /* extendhihi2 */

            default:
              return -1;
            }

        case SImode:
          switch (pattern20 (x3, SImode))
            {
            case 0:
              return 88; /* extendqisi2 */

            case 1:
              return 91; /* extendhisi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != SImode
          || !register_operand (operands[0], DImode)
          || GET_MODE (x3) != DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], SImode)
          || !
#line 488 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 11; /* *subsi3_extended */

    case MULT:
      if (pattern12 (x3) != 0
          || !
#line 544 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && TARGET_64BIT))
        return -1;
      return 17; /* *mulsi3_extended */

    case DIV:
      if (pattern12 (x3) != 0
          || !
#line 723 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 33; /* *divsi3_extended */

    case UDIV:
      if (pattern12 (x3) != 0
          || !
#line 723 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 34; /* *udivsi3_extended */

    case MOD:
      if (pattern12 (x3) != 0
          || !
#line 723 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 35; /* *modsi3_extended */

    case UMOD:
      if (pattern12 (x3) != 0
          || !
#line 723 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 36; /* *umodsi3_extended */

    case ASHIFT:
      if (pattern11 (x3) != 0
          || !
#line 1485 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 152; /* *ashlsi3_extend */

    case ASHIFTRT:
      if (pattern11 (x3) != 0
          || !
#line 1485 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 153; /* *ashrsi3_extend */

    case LSHIFTRT:
      if (pattern11 (x3) != 0
          || !
#line 1485 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 154; /* *lshrsi3_extend */

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case DImode:
      if (register_operand (operands[0], DImode)
          && GET_MODE (x3) == DImode)
        {
          switch (GET_MODE (operands[1]))
            {
            case SImode:
              if (nonimmediate_operand (operands[1], SImode)
                  && 
#line 986 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return 80; /* zero_extendsidi2 */
              break;

            case HImode:
              if (nonimmediate_operand (operands[1], HImode)
                  && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return 82; /* zero_extendhidi2 */
              break;

            case QImode:
              if (nonimmediate_operand (operands[1], QImode)
                  && 
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return 85; /* zero_extendqidi2 */
              break;

            default:
              break;
            }
        }
      break;

    case SImode:
      if (register_operand (operands[0], SImode)
          && GET_MODE (x3) == SImode)
        {
          switch (GET_MODE (operands[1]))
            {
            case HImode:
              if (nonimmediate_operand (operands[1], HImode))
                return 81; /* zero_extendhisi2 */
              break;

            case QImode:
              if (nonimmediate_operand (operands[1], QImode))
                return 84; /* zero_extendqisi2 */
              break;

            default:
              break;
            }
        }
      break;

    case HImode:
      if (register_operand (operands[0], HImode)
          && GET_MODE (x3) == HImode
          && nonimmediate_operand (operands[1], QImode))
        return 83; /* zero_extendqihi2 */
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!absolute_symbolic_operand (operands[1], VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case HImode:
      if (!register_operand (operands[0], HImode)
          || GET_MODE (x3) != HImode)
        return -1;
      switch (GET_MODE (x4))
        {
        case QImode:
          if (!
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 259; /* *local_pic_loaduqi */

        case HImode:
          if (!
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 262; /* *local_pic_loaduhi */

        case SImode:
          if (!(
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 263 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 265; /* *local_pic_loadusi */

        default:
          return -1;
        }

    case SImode:
      if (!register_operand (operands[0], SImode)
          || GET_MODE (x3) != SImode)
        return -1;
      switch (GET_MODE (x4))
        {
        case QImode:
          if (!
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 260; /* *local_pic_loaduqi */

        case HImode:
          if (!
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 263; /* *local_pic_loaduhi */

        case SImode:
          if (!(
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 263 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 266; /* *local_pic_loadusi */

        default:
          return -1;
        }

    case DImode:
      if (!register_operand (operands[0], DImode)
          || GET_MODE (x3) != DImode)
        return -1;
      switch (GET_MODE (x4))
        {
        case QImode:
          if (!(
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 261; /* *local_pic_loaduqi */

        case HImode:
          if (!(
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 264; /* *local_pic_loaduhi */

        case SImode:
          if (!(
#line 51 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 267; /* *local_pic_loadusi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (register_operand (operands[0], SImode)
              && 
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
            return 206; /* indirect_jumpsi */
          break;

        case DImode:
          if (register_operand (operands[0], DImode)
              && 
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
            return 207; /* indirect_jumpdi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      return 205; /* jump */

    case MEM:
      operands[0] = x2;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!absolute_symbolic_operand (operands[1], VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case QImode:
          if (!register_operand (operands[0], QImode)
              || GET_MODE (x3) != QImode
              || !
#line 28 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 251; /* *local_pic_loadqi */

        case HImode:
          if (!register_operand (operands[0], HImode)
              || GET_MODE (x3) != HImode
              || !
#line 28 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 252; /* *local_pic_loadhi */

        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x3) != SImode
              || !
#line 28 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 253; /* *local_pic_loadsi */

        case DImode:
          if (!register_operand (operands[0], DImode)
              || GET_MODE (x3) != DImode
              || !(
#line 28 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 266 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 254; /* *local_pic_loaddi */

        case SFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], SFmode)
              || GET_MODE (x3) != SFmode)
            return -1;
          if ((
#line 36 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
            {
              *pnum_clobbers = 1;
              return 255; /* *local_pic_loadsf */
            }
          if (!(
#line 44 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
            return -1;
          *pnum_clobbers = 1;
          return 257; /* *local_pic_loadsf */

        case DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], DFmode)
              || GET_MODE (x3) != DFmode)
            return -1;
          if ((
#line 36 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            {
              *pnum_clobbers = 1;
              return 256; /* *local_pic_loaddf */
            }
          if (!(
#line 44 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          *pnum_clobbers = 1;
          return 258; /* *local_pic_loaddf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (XINT (x3, 1) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], SImode)
          || !
#line 2058 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 224; /* riscv_frflags */

    case 2:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 18:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case SImode:
              if (!memory_operand (operands[0], SImode)
                  || GET_MODE (x3) != SImode
                  || !reg_or_0_operand (operands[1], SImode)
                  || !
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                return -1;
              return 229; /* atomic_storesi */

            case DImode:
              if (!memory_operand (operands[0], DImode)
                  || GET_MODE (x3) != DImode
                  || !reg_or_0_operand (operands[1], DImode)
                  || !(
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                return -1;
              return 230; /* atomic_storedi */

            default:
              return -1;
            }

        case 16:
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern29 (x3))
                {
                case 0:
                  if (!
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                    return -1;
                  return 231; /* atomic_addsi */

                case 1:
                  if (!(
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                    return -1;
                  return 235; /* atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern29 (x3))
                {
                case 0:
                  if (!
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                    return -1;
                  return 232; /* atomic_orsi */

                case 1:
                  if (!(
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                    return -1;
                  return 236; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern29 (x3))
                {
                case 0:
                  if (!
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                    return -1;
                  return 233; /* atomic_xorsi */

                case 1:
                  if (!(
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                    return -1;
                  return 237; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern29 (x3))
                {
                case 0:
                  if (!
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                    return -1;
                  return 234; /* atomic_andsi */

                case 1:
                  if (!(
#line 78 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                    return -1;
                  return 238; /* atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern38 (x3, SFmode) != 0
                      || !(
#line 812 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 49; /* *fmasf4 */

                case DFmode:
                  if (pattern38 (x3, DFmode) != 0
                      || !(
#line 812 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 50; /* *fmadf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern39 (x3, SFmode) != 0
                      || !(
#line 825 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 51; /* *fmssf4 */

                case DFmode:
                  if (pattern39 (x3, DFmode) != 0
                      || !(
#line 825 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 52; /* *fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern40 (x3, SFmode) != 0
                      || !(
#line 838 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 53; /* *fnmssf4 */

                case DFmode:
                  if (pattern40 (x3, DFmode) != 0
                      || !(
#line 838 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 54; /* *fnmsdf4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern41 (x3, SFmode) != 0
                      || !(
#line 851 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 55; /* *fnmasf4 */

                case DFmode:
                  if (pattern41 (x3, DFmode) != 0
                      || !(
#line 851 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 56; /* *fnmadf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern10 (x3))
        {
        case 0:
          if (!
#line 884 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 61; /* negsf2 */

        case 1:
          if (!(
#line 884 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 62; /* negdf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[1] = x3;
      if (order_operator (operands[1], VOIDmode))
        {
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          operands[1] = x3;
          if (signed_order_operator (operands[1], VOIDmode))
            {
              res = recog_3 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (pnum_clobbers == NULL
              || !equality_operator (x3, VOIDmode))
            return -1;
          operands[0] = x3;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != ZERO_EXTRACT)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x1, 0);
          if (GET_CODE (x9) != PC)
            return -1;
          x10 = XEXP (x4, 0);
          operands[2] = x10;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          if (XWINT (x5, 0) == 1LL)
            {
              x12 = XEXP (x4, 2);
              operands[3] = x12;
              if (branch_on_bit_operand (operands[3], VOIDmode))
                {
                  switch (GET_MODE (x4))
                    {
                    case SImode:
                      if (register_operand (operands[2], SImode)
                          && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
                        {
                          *pnum_clobbers = 1;
                          return 159; /* *branch_on_bitsi */
                        }
                      break;

                    case DImode:
                      if (register_operand (operands[2], DImode)
                          && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                        {
                          *pnum_clobbers = 1;
                          return 160; /* *branch_on_bitdi */
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          x12 = XEXP (x4, 2);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[3] = x5;
          if (!branch_on_bit_operand (operands[3], VOIDmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case SImode:
              if (!register_operand (operands[2], SImode)
                  || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 161; /* *branch_on_bit_rangesi */

            case DImode:
              if (!register_operand (operands[2], DImode)
                  || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 162; /* *branch_on_bit_rangedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = recog_4 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (x2))
    {
    case EQ:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern8 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 175; /* *seq_zero_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 176; /* *seq_zero_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 177; /* *seq_zero_didi */

        default:
          return -1;
        }

    case GT:
      switch (pattern15 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 181; /* *sgt_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 183; /* *sgt_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 185; /* *sgt_didi */

        default:
          return -1;
        }

    case GE:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (pattern8 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 187; /* *sge_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 189; /* *sge_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 191; /* *sge_didi */

        default:
          return -1;
        }

    case LT:
      switch (pattern16 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 193; /* *slt_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 195; /* *slt_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 197; /* *slt_didi */

        default:
          return -1;
        }

    case LE:
      switch (pattern17 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 199; /* *sle_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 201; /* *sle_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 203; /* *sle_didi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode))
        return -1;
      return 208; /* tablejumpsi */

    case DImode:
      if (!register_operand (operands[0], DImode)
          || !
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 209; /* tablejumpdi */

    default:
      return -1;
    }
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE)
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 2:
      if (XINT (x5, 1) != 16)
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], SImode))
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      switch (GET_CODE (x9))
        {
        case PLUS:
          switch (pattern48 (x5))
            {
            case 0:
              if (!
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                return -1;
              return 239; /* atomic_fetch_addsi */

            case 1:
              if (!(
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                return -1;
              return 243; /* atomic_fetch_adddi */

            default:
              return -1;
            }

        case IOR:
          switch (pattern48 (x5))
            {
            case 0:
              if (!
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                return -1;
              return 240; /* atomic_fetch_orsi */

            case 1:
              if (!(
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                return -1;
              return 244; /* atomic_fetch_ordi */

            default:
              return -1;
            }

        case XOR:
          switch (pattern48 (x5))
            {
            case 0:
              if (!
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                return -1;
              return 241; /* atomic_fetch_xorsi */

            case 1:
              if (!(
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                return -1;
              return 245; /* atomic_fetch_xordi */

            default:
              return -1;
            }

        case AND:
          switch (pattern48 (x5))
            {
            case 0:
              if (!
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                return -1;
              return 242; /* atomic_fetch_andsi */

            case 1:
              if (!(
#line 91 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                return -1;
              return 246; /* atomic_fetch_anddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pnum_clobbers == NULL
          || XINT (x5, 1) != 15)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      operands[2] = x9;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      x10 = XVECEXP (x5, 0, 2);
      operands[4] = x10;
      if (!const_int_operand (operands[4], SImode))
        return -1;
      x11 = XVECEXP (x5, 0, 3);
      operands[5] = x11;
      if (!const_int_operand (operands[5], SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (pattern53 (x5, SImode) != 0
              || !
#line 117 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
            return -1;
          *pnum_clobbers = 1;
          return 249; /* atomic_cas_value_strongsi */

        case DImode:
          if (pattern53 (x5, DImode) != 0
              || !(
#line 117 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 250; /* atomic_cas_value_strongdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!absolute_symbolic_operand (operands[0], VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (x4))
    {
    case QImode:
      switch (pattern42 (QImode))
        {
        case 0:
          if (!
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
            return -1;
          return 268; /* *local_pic_storediqi */

        case 1:
          if (!
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
            return -1;
          return 272; /* *local_pic_storesiqi */

        default:
          return -1;
        }

    case HImode:
      switch (pattern42 (HImode))
        {
        case 0:
          if (!
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
            return -1;
          return 269; /* *local_pic_storedihi */

        case 1:
          if (!
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
            return -1;
          return 273; /* *local_pic_storesihi */

        default:
          return -1;
        }

    case SImode:
      switch (pattern42 (SImode))
        {
        case 0:
          if (!
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
            return -1;
          return 270; /* *local_pic_storedisi */

        case 1:
          if (!
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])))
            return -1;
          return 274; /* *local_pic_storesisi */

        default:
          return -1;
        }

    case DImode:
      switch (pattern42 (DImode))
        {
        case 0:
          if (!(
#line 59 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 266 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 271; /* *local_pic_storedidi */

        case 1:
          if (!(
#line 67 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(!TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 266 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
            return -1;
          return 275; /* *local_pic_storesidi */

        default:
          return -1;
        }

    case SFmode:
      switch (pattern43 (SFmode))
        {
        case 0:
          if (!(
#line 75 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 276; /* *local_pic_storedisf */

        case 1:
          if (!(
#line 83 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 278; /* *local_pic_storesisf */

        default:
          return -1;
        }

    case DFmode:
      switch (pattern43 (DFmode))
        {
        case 0:
          if (!(
#line 75 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 277; /* *local_pic_storedidf */

        case 1:
          if (!(
#line 83 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 279; /* *local_pic_storesidf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (pattern0 (x2, SFmode) != 0
              || !
#line 404 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1; /* addsf3 */

        case DFmode:
          if (pattern0 (x2, DFmode) != 0
              || !(
#line 404 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 2; /* adddf3 */

        case SImode:
          if (pattern3 (x2, SImode) != 0)
            return -1;
          return 3; /* addsi3 */

        case DImode:
          if (pattern3 (x2, DImode) != 0
              || !
#line 422 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 4; /* adddi3 */

        case HImode:
          switch (pattern21 (x2))
            {
            case 0:
              return 134; /* *addhihi3 */

            case 1:
              return 135; /* *addsihi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_6 (x1, insn, pnum_clobbers);

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (pattern0 (x2, SFmode) != 0
              || !
#line 460 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 7; /* subsf3 */

        case DFmode:
          if (pattern0 (x2, DFmode) != 0
              || !(
#line 460 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 8; /* subdf3 */

        case DImode:
          if (pattern22 (x2, DImode) != 0
              || !
#line 469 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 9; /* subdi3 */

        case SImode:
          if (pattern22 (x2, SImode) != 0)
            return -1;
          return 10; /* subsi3 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case SFmode:
          if (pattern0 (x2, SFmode) != 0
              || !
#line 516 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 13; /* mulsf3 */

        case DFmode:
          if (pattern0 (x2, DFmode) != 0
              || !(
#line 516 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 14; /* muldf3 */

        case SImode:
          if (pattern0 (x2, SImode) != 0
              || !
#line 525 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL))
            return -1;
          return 15; /* mulsi3 */

        case DImode:
          if (pattern0 (x2, DImode) != 0
              || !
#line 534 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && TARGET_64BIT))
            return -1;
          return 16; /* muldi3 */

        default:
          return -1;
        }

    case TRUNCATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          switch (pattern31 (x2))
            {
            case 0:
              if (!
#line 595 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && TARGET_64BIT))
                return -1;
              return 19; /* muldi3_highpart */

            case 1:
              if (!
#line 656 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && !TARGET_64BIT))
                return -1;
              return 22; /* mulsi3_highpart */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x9 = XEXP (x6, 1);
          switch (GET_CODE (x9))
            {
            case ZERO_EXTEND:
              switch (pattern31 (x2))
                {
                case 0:
                  if (!
#line 595 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && TARGET_64BIT))
                    return -1;
                  return 20; /* umuldi3_highpart */

                case 1:
                  if (!
#line 656 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && !TARGET_64BIT))
                    return -1;
                  return 23; /* umulsi3_highpart */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern31 (x2))
                {
                case 0:
                  if (!
#line 626 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && TARGET_64BIT))
                    return -1;
                  return 21; /* usmuldi3_highpart */

                case 1:
                  if (!
#line 687 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_MUL && !TARGET_64BIT))
                    return -1;
                  return 24; /* usmulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (pattern0 (x2, SImode) != 0
              || !
#line 704 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV))
            return -1;
          return 25; /* divsi3 */

        case DImode:
          if (pattern0 (x2, DImode) != 0
              || !
#line 713 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
            return -1;
          return 29; /* divdi3 */

        case SFmode:
          if (pattern0 (x2, SFmode) != 0
              || !(
#line 732 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_FDIV) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 37; /* divsf3 */

        case DFmode:
          if (pattern0 (x2, DFmode) != 0
              || !(
#line 732 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_FDIV) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 38; /* divdf3 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 704 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV))
            return -1;
          return 26; /* udivsi3 */

        case 1:
          if (!
#line 713 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
            return -1;
          return 30; /* udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 704 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV))
            return -1;
          return 27; /* modsi3 */

        case 1:
          if (!
#line 713 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
            return -1;
          return 31; /* moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 704 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV))
            return -1;
          return 28; /* umodsi3 */

        case 1:
          if (!
#line 713 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
            return -1;
          return 32; /* umoddi3 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern10 (x2))
        {
        case 0:
          if (!(
#line 747 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_FDIV) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 39; /* sqrtsf2 */

        case 1:
          if (!(
#line 747 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_FDIV) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 40; /* sqrtdf2 */

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[3] = x11;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern32 (x2, SFmode) != 0
                      || !
#line 763 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 41; /* fmasf4 */

                case DFmode:
                  if (pattern32 (x2, DFmode) != 0
                      || !(
#line 763 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 42; /* fmadf4 */

                default:
                  return -1;
                }

            case NEG:
              x12 = XEXP (x11, 0);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern33 (x2, SFmode) != 0
                      || !
#line 775 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 43; /* fmssf4 */

                case DFmode:
                  if (pattern33 (x2, DFmode) != 0
                      || !(
#line 775 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 44; /* fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case NEG:
              x12 = XEXP (x11, 0);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern34 (x2, SFmode) != 0
                      || !
#line 787 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 45; /* fnmssf4 */

                case DFmode:
                  if (pattern34 (x2, DFmode) != 0
                      || !(
#line 787 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 46; /* fnmsdf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x11;
              switch (GET_MODE (operands[0]))
                {
                case SFmode:
                  if (pattern35 (x2, SFmode) != 0
                      || !
#line 799 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 47; /* fnmasf4 */

                case DFmode:
                  if (pattern35 (x2, DFmode) != 0
                      || !(
#line 799 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 48; /* fnmadf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_10 (x1, insn, pnum_clobbers);

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern10 (x2))
        {
        case 0:
          if (!
#line 866 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 57; /* abssf2 */

        case 1:
          if (!(
#line 866 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 58; /* absdf2 */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_5 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 63; /* sminsf3 */

        case 1:
          if (!(
#line 900 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 64; /* smindf3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 909 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 65; /* smaxsf3 */

        case 1:
          if (!(
#line 909 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 66; /* smaxdf3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern4 (x1))
        {
        case 0:
          if (
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return 67; /* andsi3 */
          if (!
#line 938 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 73; /* *andsi3_internal */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 70; /* anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern4 (x1))
        {
        case 0:
          if (
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return 68; /* iorsi3 */
          if (!
#line 938 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 74; /* *iorsi3_internal */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 71; /* iordi3 */

        default:
          return -1;
        }

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (pattern3 (x2, SImode) != 0)
            return -1;
          if (
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return 69; /* xorsi3 */
          if (!
#line 938 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 75; /* *xorsi3_internal */

        case DImode:
          if (pattern3 (x2, DImode) != 0
              || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 72; /* xordi3 */

        case HImode:
          switch (pattern21 (x2))
            {
            case 0:
              return 136; /* *xorhihi3 */

            case 1:
              return 137; /* *xorsihi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (!register_operand (operands[0], SImode)
              || GET_MODE (x2) != SImode
              || !register_operand (operands[1], SImode))
            return -1;
          if (
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return 76; /* one_cmplsi2 */
          if (!
#line 954 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 78; /* *one_cmplsi2_internal */

        case DImode:
          if (!register_operand (operands[0], DImode)
              || GET_MODE (x2) != DImode
              || !register_operand (operands[1], DImode)
              || !
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 77; /* one_cmpldi2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], DFmode)
          || !
#line 969 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 79; /* truncdfsf2 */

    case ZERO_EXTEND:
      return recog_7 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], SFmode)
          || !
#line 1069 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 93; /* extendsfdf2 */

    case FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 1084 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 94; /* fix_truncsfsi2 */

        case 1:
          if (!(
#line 1084 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 96; /* fix_truncdfsi2 */

        case 2:
          if (!(
#line 1084 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))))
            return -1;
          return 95; /* fix_truncsfdi2 */

        case 3:
          if (!(
#line 1084 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))))
            return -1;
          return 97; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 1092 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 98; /* fixuns_truncsfsi2 */

        case 1:
          if (!(
#line 1092 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 100; /* fixuns_truncdfsi2 */

        case 2:
          if (!(
#line 1092 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))))
            return -1;
          return 99; /* fixuns_truncsfdi2 */

        case 3:
          if (!(
#line 1092 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT))))
            return -1;
          return 101; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern7 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], SImode)
              && 
#line 1100 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return 102; /* floatsisf2 */
          if (!reg_or_0_operand (operands[1], DImode)
              || !(
#line 1100 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
            return -1;
          return 103; /* floatdisf2 */

        case 1:
          if (reg_or_0_operand (operands[1], SImode)
              && (
#line 1100 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return 104; /* floatsidf2 */
          if (!reg_or_0_operand (operands[1], DImode)
              || !(
#line 1100 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
            return -1;
          return 105; /* floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern7 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], SImode)
              && 
#line 1108 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return 106; /* floatunssisf2 */
          if (!reg_or_0_operand (operands[1], DImode)
              || !(
#line 1108 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
            return -1;
          return 107; /* floatunsdisf2 */

        case 1:
          if (reg_or_0_operand (operands[1], SImode)
              && (
#line 1108 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
            return 108; /* floatunssidf2 */
          if (!reg_or_0_operand (operands[1], DImode)
              || !(
#line 1108 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
            return -1;
          return 109; /* floatunsdidf2 */

        default:
          return -1;
        }

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (pattern24 (x2, SImode) != 0
              || !
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode))
            return -1;
          return 128; /* *lowsi */

        case DImode:
          if (pattern24 (x2, DImode) != 0
              || !
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode))
            return -1;
          return 129; /* *lowdi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_8 (x1, insn, pnum_clobbers);

    case ASHIFT:
      switch (pattern4 (x1))
        {
        case 0:
          return 146; /* ashlsi3 */

        case 1:
          if (!
#line 1469 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 149; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern4 (x1))
        {
        case 0:
          return 147; /* ashrsi3 */

        case 1:
          if (!
#line 1469 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 150; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern4 (x1))
        {
        case 0:
          return 148; /* lshrsi3 */

        case 1:
          if (!
#line 1469 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 151; /* lshrdi3 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_11 (x1, insn, pnum_clobbers);

    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      return recog_12 (x1, insn, pnum_clobbers);

    case NE:
      switch (pattern9 (x1, 0))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 178; /* *sne_zero_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 179; /* *sne_zero_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 180; /* *sne_zero_didi */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern15 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 182; /* *sgtu_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 184; /* *sgtu_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 186; /* *sgtu_didi */

        default:
          return -1;
        }

    case GEU:
      switch (pattern9 (x1, 1))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 188; /* *sgeu_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 190; /* *sgeu_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 192; /* *sgeu_didi */

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern16 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 194; /* *sltu_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 196; /* *sltu_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 198; /* *sltu_didi */

        default:
          return -1;
        }

    case LEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern17 (x2))
        {
        case 0:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
            return -1;
          return 200; /* *sleu_sisi */

        case 1:
          if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 202; /* *sleu_disi */

        case 2:
          if (!
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 204; /* *sleu_didi */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!call_insn_operand (operands[1], VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (
#line 1947 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(SIBLING_CALL_P (insn)))
        return 216; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 218; /* call_value_internal */

    case UNSPEC_VOLATILE:
      return recog_9 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_16 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 144; /* fence */

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 145; /* fence_i */

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 210; /* blockage */

        case 0:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], VOIDmode))
            return -1;
          *pnum_clobbers = 2;
          return 221; /* gpr_save */

        case 1:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], VOIDmode))
            return -1;
          return 222; /* gpr_restore */

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!csr_operand (operands[0], SImode)
              || !
#line 2063 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 225; /* riscv_fsflags */

        default:
          return -1;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 1);
              switch (GET_CODE (x3))
                {
                case IF_THEN_ELSE:
                  if (pattern18 (x2) != 0)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x5 = XEXP (x3, 0);
                  x6 = XEXP (x5, 0);
                  x7 = XEXP (x6, 0);
                  operands[2] = x7;
                  x8 = XEXP (x3, 1);
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  x10 = XEXP (x4, 0);
                  operands[4] = x10;
                  x11 = XEXP (x6, 1);
                  if (XWINT (x11, 0) == 1LL)
                    {
                      switch (pattern50 (x6))
                        {
                        case 0:
                          if (
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
                            return 159; /* *branch_on_bitsi */
                          break;

                        case 1:
                          if (
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                            return 160; /* *branch_on_bitdi */
                          break;

                        default:
                          break;
                        }
                    }
                  x12 = XEXP (x6, 2);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  switch (pattern51 (x6))
                    {
                    case 0:
                      if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))
                        return -1;
                      return 161; /* *branch_on_bit_rangesi */

                    case 1:
                      if (!
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                        return -1;
                      return 162; /* *branch_on_bit_rangedi */

                    default:
                      return -1;
                    }

                case UNSPEC:
                  x13 = XEXP (x2, 0);
                  operands[0] = x13;
                  switch (XVECLEN (x3, 0))
                    {
                    case 2:
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) != CLOBBER)
                        return -1;
                      x14 = XVECEXP (x3, 0, 0);
                      operands[1] = x14;
                      x15 = XVECEXP (x3, 0, 1);
                      operands[2] = x15;
                      x10 = XEXP (x4, 0);
                      operands[3] = x10;
                      switch (XINT (x3, 1))
                        {
                        case 9:
                          switch (GET_MODE (operands[0]))
                            {
                            case SImode:
                              switch (pattern45 (x3, SImode))
                                {
                                case 0:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                                    return -1;
                                  return 167; /* flt_quietsfsi4 */

                                case 1:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                                    return -1;
                                  return 171; /* flt_quietdfsi4 */

                                default:
                                  return -1;
                                }

                            case DImode:
                              switch (pattern45 (x3, DImode))
                                {
                                case 0:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                                    return -1;
                                  return 169; /* flt_quietsfdi4 */

                                case 1:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                                    return -1;
                                  return 173; /* flt_quietdfdi4 */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        case 10:
                          switch (GET_MODE (operands[0]))
                            {
                            case SImode:
                              switch (pattern45 (x3, SImode))
                                {
                                case 0:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                                    return -1;
                                  return 168; /* fle_quietsfsi4 */

                                case 1:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT))))
                                    return -1;
                                  return 172; /* fle_quietdfsi4 */

                                default:
                                  return -1;
                                }

                            case DImode:
                              switch (pattern45 (x3, DImode))
                                {
                                case 0:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                                    return -1;
                                  return 170; /* fle_quietsfdi4 */

                                case 1:
                                  if (!(
#line 1671 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (((
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))))
                                    return -1;
                                  return 174; /* fle_quietdfdi4 */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1:
                      if (XINT (x3, 1) != 19
                          || GET_MODE (x3) != BLKmode)
                        return -1;
                      x4 = XVECEXP (x1, 0, 1);
                      operands[1] = x4;
                      if (!const_int_operand (operands[1], SImode))
                        return -1;
                      x14 = XVECEXP (x3, 0, 0);
                      if (!rtx_equal_p (x14, operands[0]))
                        return -1;
                      return 228; /* mem_thread_fence_1 */

                    default:
                      return -1;
                    }

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case REG:
                case SUBREG:
                case MEM:
                  x13 = XEXP (x2, 0);
                  switch (GET_CODE (x13))
                    {
                    case PC:
                      res = recog_13 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    case REG:
                    case SUBREG:
                      res = recog_14 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    case MEM:
                      res = recog_15 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    default:
                      break;
                    }
                  if (GET_CODE (x3) != MEM)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  operands[0] = x13;
                  x5 = XEXP (x3, 0);
                  operands[1] = x5;
                  if (!absolute_symbolic_operand (operands[1], VOIDmode))
                    return -1;
                  x10 = XEXP (x4, 0);
                  operands[2] = x10;
                  switch (GET_MODE (operands[0]))
                    {
                    case SFmode:
                      switch (pattern44 (x3, SFmode))
                        {
                        case 0:
                          if (!(
#line 36 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
                            return -1;
                          return 255; /* *local_pic_loadsf */

                        case 1:
                          if (!(
#line 44 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 269 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT)))
                            return -1;
                          return 257; /* *local_pic_loadsf */

                        default:
                          return -1;
                        }

                    case DFmode:
                      switch (pattern44 (x3, DFmode))
                        {
                        case 0:
                          if (!(
#line 36 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                            return -1;
                          return 256; /* *local_pic_loaddf */

                        case 1:
                          if (!(
#line 44 "../../gcc-7.2.1-20170915/gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 270 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT)))
                            return -1;
                          return 258; /* *local_pic_loaddf */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case CALL:
                  x5 = XEXP (x3, 0);
                  if (GET_CODE (x5) != MEM
                      || GET_MODE (x5) != SImode)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (pattern19 (x4, 1) != 0)
                    return -1;
                  x13 = XEXP (x2, 0);
                  operands[0] = x13;
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (!call_insn_operand (operands[1], VOIDmode))
                    return -1;
                  x8 = XEXP (x3, 1);
                  operands[2] = x8;
                  return 218; /* call_value_internal */

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x3, 0) != 2
                      || XINT (x3, 1) != 17)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != SET)
                    return -1;
                  x13 = XEXP (x2, 0);
                  operands[0] = x13;
                  x14 = XVECEXP (x3, 0, 0);
                  operands[1] = x14;
                  x15 = XVECEXP (x3, 0, 1);
                  operands[3] = x15;
                  if (!const_int_operand (operands[3], SImode))
                    return -1;
                  x16 = XEXP (x4, 1);
                  operands[2] = x16;
                  x10 = XEXP (x4, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case SImode:
                      if (pattern46 (x3, SImode) != 0
                          || !
#line 103 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                        return -1;
                      return 247; /* atomic_exchangesi */

                    case DImode:
                      if (pattern46 (x3, DImode) != 0
                          || !(
#line 103 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                        return -1;
                      return 248; /* atomic_exchangedi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return -1;
              x10 = XEXP (x4, 0);
              operands[0] = x10;
              if (!pmode_register_operand (operands[0], VOIDmode))
                return -1;
              return 212; /* simple_return_internal */

            case UNSPEC:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 0)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x17 = XVECEXP (x2, 0, 0);
              operands[0] = x17;
              x10 = XEXP (x4, 0);
              operands[1] = x10;
              switch (GET_MODE (operands[0]))
                {
                case SImode:
                  if (!register_operand (operands[0], SImode)
                      || !scratch_operand (operands[1], SImode)
                      || !
#line 1883 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
                    return -1;
                  return 213; /* eh_set_lr_si */

                case DImode:
                  if (!register_operand (operands[0], DImode)
                      || !scratch_operand (operands[1], DImode)
                      || !
#line 1889 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                    return -1;
                  return 214; /* eh_set_lr_di */

                default:
                  return -1;
                }

            case CALL:
              x13 = XEXP (x2, 0);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != SImode)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern19 (x4, 1) != 0)
                return -1;
              x18 = XEXP (x13, 0);
              operands[0] = x18;
              if (!call_insn_operand (operands[0], VOIDmode))
                return -1;
              x3 = XEXP (x2, 1);
              operands[1] = x3;
              return 217; /* call_internal */

            default:
              return -1;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 0)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern19 (x4, 5) != 0)
                return -1;
              x19 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x19) != CLOBBER)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 6
                  || GET_MODE (x20) != SImode)
                return -1;
              x17 = XVECEXP (x2, 0, 0);
              operands[0] = x17;
              if (!const_int_operand (operands[0], VOIDmode))
                return -1;
              return 221; /* gpr_save */

            case RETURN:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return -1;
              x19 = XVECEXP (x1, 0, 2);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x10 = XEXP (x4, 0);
              operands[0] = x10;
              if (!pmode_register_operand (operands[0], VOIDmode))
                return -1;
              return 223; /* gpr_restore_return */

            case SET:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x16 = XEXP (x4, 1);
              if (GET_CODE (x16) != UNSPEC_VOLATILE
                  || XVECLEN (x16, 0) != 4
                  || XINT (x16, 1) != 15)
                return -1;
              x19 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x19) != CLOBBER)
                return -1;
              x13 = XEXP (x2, 0);
              operands[0] = x13;
              x3 = XEXP (x2, 1);
              operands[1] = x3;
              x21 = XVECEXP (x16, 0, 0);
              operands[2] = x21;
              x22 = XVECEXP (x16, 0, 1);
              operands[3] = x22;
              x23 = XVECEXP (x16, 0, 2);
              operands[4] = x23;
              if (!const_int_operand (operands[4], SImode))
                return -1;
              x24 = XVECEXP (x16, 0, 3);
              operands[5] = x24;
              if (!const_int_operand (operands[5], SImode))
                return -1;
              x20 = XEXP (x19, 0);
              operands[6] = x20;
              x10 = XEXP (x4, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case SImode:
                  if (pattern52 (x16, SImode) != 0
                      || !
#line 117 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC))
                    return -1;
                  return 249; /* atomic_cas_value_strongsi */

                case DImode:
                  if (pattern52 (x16, DImode) != 0
                      || !(
#line 117 "../../gcc-7.2.1-20170915/gcc/config/riscv/sync.md"
(TARGET_ATOMIC) && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                    return -1;
                  return 250; /* atomic_cas_value_strongdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 211; /* simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case SImode:
          if (!register_operand (operands[0], SImode)
              || !
#line 1883 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 213; /* eh_set_lr_si */

        case DImode:
          if (!register_operand (operands[0], DImode)
              || !
#line 1889 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 214; /* eh_set_lr_di */

        default:
          return -1;
        }

    case CALL:
      x25 = XEXP (x1, 0);
      if (GET_CODE (x25) != MEM
          || GET_MODE (x25) != SImode)
        return -1;
      x26 = XEXP (x25, 0);
      operands[0] = x26;
      if (!call_insn_operand (operands[0], VOIDmode))
        return -1;
      x27 = XEXP (x1, 1);
      operands[1] = x27;
      if (
#line 1924 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(SIBLING_CALL_P (insn)))
        return 215; /* sibcall_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 217; /* call_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 219; /* nop */

    case TRAP_IF:
      x25 = XEXP (x1, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x27 = XEXP (x1, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 220; /* trap */

    default:
      return -1;
    }
}

static rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case SImode:
      if (!register_operand (operands[0], SImode)
          || !register_operand (operands[2], SImode))
        return NULL;
      if (splittable_const_int_operand (operands[1], SImode))
        return gen_split_10 (insn, operands);
      if (!(
#line 1213 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == SImode)))
        return NULL;
      return gen_split_12 (insn, operands);

    case DImode:
      if (!register_operand (operands[0], DImode)
          || !register_operand (operands[2], DImode))
        return NULL;
      if (splittable_const_int_operand (operands[1], DImode)
          && 
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return gen_split_11 (insn, operands);
      if (!(
#line 1213 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 238 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_13 (insn, operands);

    default:
      return NULL;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case DImode:
              if (!register_operand (operands[0], DImode)
                  || GET_MODE (x3) != DImode)
                return NULL;
              switch (GET_MODE (operands[1]))
                {
                case SImode:
                  if (!nonimmediate_operand (operands[1], SImode)
                      || !(
#line 986 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 990 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1]))))
                    return NULL;
                  return gen_split_1 (insn, operands);

                case HImode:
                  if (!nonimmediate_operand (operands[1], HImode)
                      || !(
#line 234 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 1006 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1]))))
                    return NULL;
                  return gen_split_3 (insn, operands);

                default:
                  return NULL;
                }

            case SImode:
              if (!register_operand (operands[0], SImode)
                  || GET_MODE (x3) != SImode
                  || !nonimmediate_operand (operands[1], HImode)
                  || !
#line 1006 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1])))
                return NULL;
              return gen_split_2 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case HImode:
              switch (pattern20 (x3, HImode))
                {
                case 0:
                  if (!
#line 1054 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1])))
                    return NULL;
                  return gen_split_4 (insn, operands);

                case 1:
                  if (!
#line 1054 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1])))
                    return NULL;
                  return gen_split_7 (insn, operands);

                default:
                  return NULL;
                }

            case SImode:
              switch (pattern20 (x3, SImode))
                {
                case 0:
                  if (!
#line 1054 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1])))
                    return NULL;
                  return gen_split_5 (insn, operands);

                case 1:
                  if (!
#line 1054 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1])))
                    return NULL;
                  return gen_split_8 (insn, operands);

                default:
                  return NULL;
                }

            case DImode:
              switch (pattern20 (x3, DImode))
                {
                case 0:
                  if (!(
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 1054 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1]))))
                    return NULL;
                  return gen_split_6 (insn, operands);

                case 1:
                  if (!(
#line 260 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 1054 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
( reload_completed && REG_P (operands[1]))))
                    return NULL;
                  return gen_split_9 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case DImode:
              if (!nonimmediate_operand (operands[0], DImode)
                  || !move_operand (operands[1], DImode)
                  || !
#line 1414 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed
   && riscv_split_64bit_move_p (operands[0], operands[1])))
                return NULL;
              return gen_split_14 (insn, operands);

            case DFmode:
              if (!nonimmediate_operand (operands[0], DFmode)
                  || !move_operand (operands[1], DFmode)
                  || !
#line 1414 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed
   && riscv_split_64bit_move_p (operands[0], operands[1])))
                return NULL;
              return gen_split_15 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return NULL;
      x6 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x6))
        {
        case SET:
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != IF_THEN_ELSE
              || pattern18 (x6) != 0)
            return NULL;
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          x12 = XEXP (x8, 1);
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          x14 = XEXP (x5, 0);
          operands[4] = x14;
          x15 = XEXP (x10, 1);
          if (XWINT (x15, 0) == 1LL)
            {
              switch (pattern50 (x10))
                {
                case 0:
                  if ((
#line 1578 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT)))
                    return gen_split_16 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1578 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                    return gen_split_17 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x16 = XEXP (x10, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          switch (pattern51 (x10))
            {
            case 0:
              if (!(
#line 1609 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(!TARGET_64BIT)))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (!(
#line 1609 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 241 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_19 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 0)
            return NULL;
          x17 = XVECEXP (x6, 0, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], VOIDmode))
            return NULL;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!scratch_operand (operands[1], VOIDmode)
              || !
#line 1895 "../../gcc-7.2.1-20170915/gcc/config/riscv/riscv.md"
(reload_completed))
            return NULL;
          return gen_split_20 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != DImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], DImode))
    return NULL;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], DImode))
    return NULL;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], VOIDmode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != LSHIFTRT
      || GET_MODE (x7) != DImode)
    return NULL;
  x8 = XEXP (x6, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], DImode))
    return NULL;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return NULL;
  x10 = XEXP (x7, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return NULL;
  x11 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x11) != SET)
    return NULL;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != ASHIFT
      || GET_MODE (x12) != DImode)
    return NULL;
  x13 = XEXP (x11, 0);
  operands[4] = x13;
  if (!register_operand (operands[4], DImode))
    return NULL;
  x14 = XEXP (x12, 1);
  operands[5] = x14;
  if (!const_int_operand (operands[5], VOIDmode))
    return NULL;
  x15 = XEXP (x12, 0);
  if (!rtx_equal_p (x15, operands[3])
      || !
#line 30 "../../gcc-7.2.1-20170915/gcc/config/riscv/peephole.md"
(TARGET_64BIT
   && INTVAL (operands[5]) < INTVAL (operands[2])
   && (REGNO (operands[3]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[3]))))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_1 (insn, operands);
}
